<template>
  <div>
    <!-- Content Header (Page header) -->
    <section class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1>Clients</h1>
          </div>
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item">
                <a href="#">Home</a>
              </li>
              <li class="breadcrumb-item active">Clients</li>
            </ol>
          </div>
        </div>
      </div>
      <!-- /.container-fluid -->
    </section>
    <!-- Main content -->
    <section class="content">
      <!-- Default box -->
      <v-card-title>
        <v-text-field
          v-model="search"
          append-icon="mdi-magnify"
          label="Search"
          single-line
          hide-details
        ></v-text-field>
      </v-card-title>
      <div class="container-fluid">
        <v-data-table
          data-app
          :headers="headers"
          :items="clients"
          :search="search"
          sort-by="clientId"
          class="elevation-1"
          :loading="loading"
        >
          <template v-slot:item.actions="{ item }">
            <v-icon small class="mr-2" @click="goTo(item)">
              mdi-account-arrow-right-outline
            </v-icon>
          </template>
        </v-data-table>
      </div>
      <!-- /.card -->
    </section>
  </div>
</template>

<script>
import trainer from "../controllers/trainer.controller";
import clientController from "../controllers/client.controller";
import swal from "sweetalert2";
export default {
  name: "Clients",
  computed: {
    user() {
      return this.$store.getters.getAuthUser;
    },
  },
  data() {
    return {
      search: "",
      headers: [
        {
          text: "Client Id",
          align: "start",
          sortable: true,
          value: "clientId",
        },
        { text: "First name", value: "firstName" },
        { text: "Middle name", value: "middleName" },
        { text: "Last name", value: "lastName" },
        { text: "Email", value: "email" },
        { text: "Phone", value: "phone" },
        { text: "Address", value: "address" },
        { text: "Postal code", value: "postalCode" },
        { text: "DOB", value: "dob" },
        { text: "Go to", value: "actions", sortable: false },
      ],
      clients: [],
      loading: true,
    };
  },
  mounted() {
    this.fillData();
  },
  methods: {
    async fillData() {
      try {
        if (this.user.role == "Trainer") {
        const clients = await trainer.getTrainersClients(this.user.trainerId);
        if (clients) {
          this.clients = clients;
          this.clients.forEach((client) => {
            client.dob = client.dob.split("T")[0];
          });
        }
      } else if (this.user.role == 'Admin') {
        const clients = await clientController.getAllClients();
        if (clients.status == 200) {
          this.clients = clients.data;
          this.clients.forEach(client => {
            client.dob = client.dob.split("T")[0];
          })
        } else {
          swal.fire("oops..", "Something went wrong", "error")
        }
      }
      } catch (e) {
        swal.fire("oops..", "Something went wrong", "error")
      }
      

      this.loading = false;
    },
    goTo(client) {
      this.$router.push(`/client/${client.clientId}`);
    },
  },
};
</script>

<style>
</style>
